<template>
  <div>
    <q-btn  style="margin-top:30px; margin-left: 30px" color="orange" to="/kategori" icon="arrow_back"
            label="Kembali" />
    <div class="q-pa-md" style="width: 80%; background: #4caf50; color: white; margin-top: 30px; margin-left: auto; margin-right: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
      <h6 style="margin: 0px">Ubah Kategori</h6>
    </div>
    <q-form
      @submit="submitKategori"
    >
      <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
        <div>
          <p>&nbsp;</p>
          <h6 style="margin-left: 70px; margin-top: 0px; margin-bottom: 10px">Data Kategori</h6>
          <div class="q-gutter-y-md" style="width: 85%; margin: auto" >
            <q-select standout="bg-green text-white" v-model="parent" :options="optionsParent" ref="inputParent" @input="resetInputParent" label="Modul" />
            <q-input standout="bg-green text-white"  v-model="form.category" label="Nama Kategori" :rules="[val => !!val || 'Tolong Masukan Kategori']"/>
            <q-input standout="bg-green text-white" v-model="form.category_desc" label="Deskripsi Kategori" type="textarea" />
            <div class="row">
              <p style="font-size: 18px; margin-right: 50px">Web Logo</p>
              <q-file hint="Biarkan Kosong Apabila Gambar tidak diubah" filled bottom-slots v-model="form.img_web"
                      @input="previewImgWeb"
                      counter
                      accept="image/*">
                <template v-slot:prepend>
                  <q-icon name="cloud_upload" @click.stop />
                </template>
              </q-file>
              <q-img :src="previewWeb" style="max-width: 200px" />
            </div>
            <div class="row">
              <p style="font-size: 18px; margin-right: 30px">Mobile Logo</p>
              <q-file hint="Biarkan Kosong Apabila Gambar Tidak di ubah" filled bottom-slots use-chips
                      @input="previewImgMobile"
                      v-model="form.img_mobile" counter
                      accept="image/*">
                <template v-slot:prepend>
                  <q-icon name="cloud_upload" @click.stop />
                </template>
              </q-file>
              <q-img :src="previewMobile" style="max-width: 200px" />
            </div>
            <li style="margin-top: 5px">Format gambar yang di izinkan adalah .jpg, jpeg, & .png</li>
            <li style="margin-top: 5px">Max Ukuran Gambar adalah 1.5 MB</li>
          </div>
          <p>&nbsp;</p>
        </div>
      </div>
      <div style="margin-top: 20px; margin-left: auto; margin-right:auto; margin-bottom: 50px; width: 80%">
        <q-btn  label="Simpan Kategori" type="submit" color="green"/>
      </div>
      <p>&nbsp;</p>
    </q-form>
  </div>
</template>

<script>
  export default {
    name: "EditKategori",

    data() {
      return {
        previewMobile: null,
        previewWeb:null,
        token: localStorage.getItem("token"),
        optionsParent: null,
        parent: null,
        form: {
          parent_id: null,
          category  : null,
          category_desc  : null,
          img_web  : null,
          img_mobile  : null,
        }
      }
    },

    beforeMount() {
      this.getKategoriById(this.$route.params.id)

    },

    methods: {
      previewImgWeb(val) {
        this.previewWeb = URL.createObjectURL(val);
      },
      previewImgMobile(val) {
        this.previewMobile = URL.createObjectURL(val);
      },

      async getKategoriById(id) {
        let config = {
          method: 'get',
          url: 'api/category/detail/' + id,
          headers: {
            'Authorization': 'Bearer ' + this.token
          }
        };

        this.$q.loading.show()
        this.$axios(config)
          .then(sukses => {
            this.form = sukses.data
            this.previewMobile = sukses.data.img_mobile;
            this.previewWeb = sukses.data.img_web;
            this.form.img_mobile = ""
            this.form.img_web = ""
            this.getListParent()
          })
          .catch(error => {
            console.log(error);
          })
          .then(always => {
            this.$q.loading.hide()
          })


      },

      async submitKategori() {
        let accept = true;

        if (accept !== true) {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: 'Mohon Periksa Kembali Form Anda'
          })
        }
        else {
          this.$q.loading.show()
          var data = new FormData();
          data.append('parent_id', this.parent.value);
          data.append('category', this.form.category);
          data.append('category_desc', this.form.category_desc);
          if (this.form.img_web) {
            data.append('img_web', this.form.img_web);
          }
          if (this.form.img_mobile) {
            data.append('img_mobile', this.form.img_mobile);
          }

          let dataApi = {
            method: "POST",
            url: "api/category/edit/" + this.$route.params.id,
            data: data,
            headers: {
              Authorization: "Bearer " + localStorage.getItem("token")
            }
          }

          this.$axios(dataApi)
            .then(sukses => {
              this.$router.push("/kategori")
              this.$q.notify({
                color: 'green-4',
                position: "top",
                textColor: 'white',
                icon: 'cloud_done',
                message: 'Berhasil Menambahkan Kategori'
              })
            })
            .catch(sukses => {})
            .then(selalu => {
              this.$q.loading.hide()
            })
        }
      },

      resetInputParent() {
        this.$refs.inputParent.resetValidation();
      },

      getListParent() {
        let dataApi = {
          methods: "GET",
          url: "api/product-type/list/select",
          headers: {
            Authorization: "Bearer " + localStorage.getItem("token")
          }
        }
        this.$q.loading.show()
        this.$axios(dataApi)
          .then(sukses => {
            this.optionsParent = sukses.data

            if (this.form.parent_id) {

              let dataParent = this.optionsParent.filter(data => {
                return data.value == this.form.parent_id
              })
              this.parent = dataParent[0]
            }

          })
          .catch(gagal => {})
          .then(selalu => {
            this.$q.loading.hide()
          })
      }
    }
  }
</script>

<style scoped>

</style>
